<template>
  <a-spin :spinning="confirmLoading">
    <j-form-container :disabled="formDisabled">
      <a-form :form="form" slot="detail">
        <a-row>
          <a-col :span="24">
            <a-form-item label="采购方总部编码" :labelCol="labelCol" :wrapperCol="wrapperCol">
              <a-input v-decorator="['purchaserhqcode']" placeholder="请输入采购方总部编码"></a-input>
            </a-form-item>
          </a-col>
          <a-col :span="24">
            <a-form-item label="供应商编码" :labelCol="labelCol" :wrapperCol="wrapperCol">
              <a-input v-decorator="['suppliercode']" placeholder="请输入供应商编码"></a-input>
            </a-form-item>
          </a-col>
          <a-col :span="24">
            <a-form-item label="供应商名称" :labelCol="labelCol" :wrapperCol="wrapperCol">
              <a-input v-decorator="['suppliername']" placeholder="请输入供应商名称"></a-input>
            </a-form-item>
          </a-col>
          <a-col :span="24">
            <a-form-item label="实物ID" :labelCol="labelCol" :wrapperCol="wrapperCol">
              <a-input v-decorator="['entitycode']" placeholder="请输入实物ID"></a-input>
            </a-form-item>
          </a-col>
          <a-col :span="24">
            <a-form-item label="采购订单行项目id" :labelCol="labelCol" :wrapperCol="wrapperCol">
              <a-input v-decorator="['poitemid']" placeholder="请输入采购订单行项目id"></a-input>
            </a-form-item>
          </a-col>
          <a-col :span="24">
            <a-form-item label="实物生产状态:0：未生产 1：生产中 2：生产完成" :labelCol="labelCol" :wrapperCol="wrapperCol">
              <a-input v-decorator="['entitystatus']" placeholder="请输入实物生产状态:0：未生产 1：生产中 2：生产完成"></a-input>
            </a-form-item>
          </a-col>
          <a-col :span="24">
            <a-form-item label="数据来源:0：供应商， 1：网关， 2：代理" :labelCol="labelCol" :wrapperCol="wrapperCol">
              <a-input v-decorator="['datasource']" placeholder="请输入数据来源:0：供应商， 1：网关， 2：代理"></a-input>
            </a-form-item>
          </a-col>
          <a-col :span="24">
            <a-form-item label="来源数据创建时间" :labelCol="labelCol" :wrapperCol="wrapperCol">
              <j-date placeholder="请选择来源数据创建时间" v-decorator="['datasourcecreatetime']" :trigger-change="true" style="width: 100%"/>
            </a-form-item>
          </a-col>
          <a-col :span="24">
            <a-form-item label="备注" :labelCol="labelCol" :wrapperCol="wrapperCol">
              <a-input v-decorator="['remark']" placeholder="请输入备注"></a-input>
            </a-form-item>
          </a-col>
          <a-col :span="24">
            <a-form-item label="数据拥有方" :labelCol="labelCol" :wrapperCol="wrapperCol">
              <a-input v-decorator="['ownerid']" placeholder="请输入数据拥有方"></a-input>
            </a-form-item>
          </a-col>
          <a-col :span="24">
            <a-form-item label="数据可见方" :labelCol="labelCol" :wrapperCol="wrapperCol">
              <a-input v-decorator="['openid']" placeholder="请输入数据可见方"></a-input>
            </a-form-item>
          </a-col>
          <!-- <a-col :span="24">
            <a-form-item label="审核日期记录" :labelCol="labelCol" :wrapperCol="wrapperCol">
              <j-date placeholder="请选择审核日期记录" v-decorator="['fapprovedate']" :trigger-change="true" style="width: 100%"/>
            </a-form-item>
          </a-col> -->
          <a-col :span="24">
            <a-form-item label="实物ID编码" :labelCol="labelCol" :wrapperCol="wrapperCol">
              <a-input v-decorator="['fbillno']" placeholder="请输入实物ID编码"></a-input>
            </a-form-item>
          </a-col>
          <a-col :span="24">
            <a-form-item label="实体主键" :labelCol="labelCol" :wrapperCol="wrapperCol">
              <a-input v-decorator="['fid']" placeholder="请输入实体主键"></a-input>
            </a-form-item>
          </a-col>
          <a-col v-if="showFlowSubmitButton" :span="24" style="text-align: center">
            <a-button @click="submitForm">提 交</a-button>
          </a-col>
        </a-row>
      </a-form>
    </j-form-container>
  </a-spin>
</template>

<script>

  import { httpAction, getAction } from '@/api/manage'
  import pick from 'lodash.pick'
  import { validateDuplicateValue } from '@/utils/util'
  import JFormContainer from '@/components/jeecg/JFormContainer'
  import JDate from '@/components/jeecg/JDate'  

  export default {
    name: 'SupplierEndPhysicalidCopyForm',
    components: {
      JFormContainer,
      JDate,
    },
    props: {
      //流程表单data
      formData: {
        type: Object,
        default: ()=>{},
        required: false
      },
      //表单模式：true流程表单 false普通表单
      formBpm: {
        type: Boolean,
        default: false,
        required: false
      },
      //表单禁用
      disabled: {
        type: Boolean,
        default: false,
        required: false
      }
    },
    data () {
      return {
        form: this.$form.createForm(this),
        model: {},
        labelCol: {
          xs: { span: 24 },
          sm: { span: 5 },
        },
        wrapperCol: {
          xs: { span: 24 },
          sm: { span: 16 },
        },
        confirmLoading: false,
        validatorRules: {
        },
        url: {
          add: "/basedata/supplierEndPhysicalidCopy/add",
          edit: "/basedata/supplierEndPhysicalidCopy/edit",
          queryById: "/basedata/supplierEndPhysicalidCopy/queryById"
        }
      }
    },
    computed: {
      formDisabled(){
        if(this.formBpm===true){
          if(this.formData.disabled===false){
            return false
          }
          return true
        }
        return this.disabled
      },
      showFlowSubmitButton(){
        if(this.formBpm===true){
          if(this.formData.disabled===false){
            return true
          }
        }
        return false
      }
    },
    created () {
      //如果是流程中表单，则需要加载流程表单data
      this.showFlowData();
    },
    methods: {
      add () {
        this.edit({});
      },
      edit (record) {
        this.form.resetFields();
        this.model = Object.assign({}, record);
        this.visible = true;
        this.$nextTick(() => {
          this.form.setFieldsValue(pick(this.model,'purchaserhqcode','suppliercode','suppliername','entitycode','poitemid','entitystatus','datasource','datasourcecreatetime','remark','ownerid','openid','fapprovedate','fbillno','fid'))
        })
      },
      //渲染流程表单数据
      showFlowData(){
        if(this.formBpm === true){
          let params = {id:this.formData.dataId};
          getAction(this.url.queryById,params).then((res)=>{
            if(res.success){
              this.edit (res.result);
            }
          });
        }
      },
      submitForm () {
        const that = this;
        // 触发表单验证
        this.form.validateFields((err, values) => {
          if (!err) {
            that.confirmLoading = true;
            let httpurl = '';
            let method = '';
            if(!this.model.id){
              httpurl+=this.url.add;
              method = 'post';
            }else{
              httpurl+=this.url.edit;
               method = 'put';
            }
            let formData = Object.assign(this.model, values);
            console.log("表单提交数据",formData)
            httpAction(httpurl,formData,method).then((res)=>{
              if(res.success){
                that.$message.success(res.message);
                that.$emit('ok');
              }else{
                that.$message.warning(res.message);
              }
            }).finally(() => {
              that.confirmLoading = false;
            })
          }
         
        })
      },
      popupCallback(row){
        this.form.setFieldsValue(pick(row,'purchaserhqcode','suppliercode','suppliername','entitycode','poitemid','entitystatus','datasource','datasourcecreatetime','remark','ownerid','openid','fapprovedate','fbillno','fid'))
      },
    }
  }
</script>